-- name: [CS] SUPER MARIO SUPER SHOW BADDIES
-- description: Oh no! Mouser and Tryclyde found their way back to the Mushroom kingdom! \n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!



local E_MODEL_TRYCLYDE = smlua_model_util_get_id("tryclyde_geo")
local E_MODEL_MOUSER = smlua_model_util_get_id("mouser_geo")

local TEX_TRYCLYDE = get_texture_info("tryclyde_icon")
local TEX_MOUSER_ICON = get_texture_info("mouser-icon")

local TEXT_MOD_NAME = "[CS] SUPER MARIO SUPER SHOW BADDIES"

local VOICETABLE_TRYCLYDE = {
    [CHAR_SOUND_ATTACKED] = 't_ATTACKED.ogg',
    [CHAR_SOUND_COUGHING1] = 't_COUGHING_1.ogg',
    [CHAR_SOUND_COUGHING2] = 't_COUGHING_2.ogg',
    [CHAR_SOUND_COUGHING3] = 't_COUGHING_3.ogg',
    [CHAR_SOUND_DOH] = {'t_DOH.ogg'},
    [CHAR_SOUND_DROWNING] = 't_DROWNING.ogg',
    [CHAR_SOUND_DYING] = 't_DYING.ogg',
    [CHAR_SOUND_EEUH] = 't_EEUH.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 't_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_HAHA] = 't_HAHA.ogg',
    [CHAR_SOUND_HAHA_2] = 't_HAHA_2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 't_HERE_WE_GO.ogg',
    [CHAR_SOUND_HOOHOO] = 't_HOOHOO.ogg',
    [CHAR_SOUND_HRMM] = 't_HRMM.ogg',
    [CHAR_SOUND_IMA_TIRED] = 't_IMA_TIRED.ogg',
    [CHAR_SOUND_MAMA_MIA] = 't_MAMA_MIA.ogg',
    [CHAR_SOUND_LETS_A_GO] = 't_LETS_A_GO.ogg',
    [CHAR_SOUND_ON_FIRE] = 't_ON_FIRE.ogg',
    [CHAR_SOUND_OOOF] = 't_OOOF.ogg',
    [CHAR_SOUND_OOOF2] = 't_OOOF2.ogg',
    [CHAR_SOUND_PANTING] = 't_PANTING.ogg',
    [CHAR_SOUND_PANTING_COLD] = 't_PANTING_COLD.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 't_PUNCH_HOO.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 't_PUNCH_WAH.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 't_PUNCH_YAH.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 't_SO_LONGA_BOWSER.ogg',
    [CHAR_SOUND_SNORING1] = 't_SNORING1.ogg',
    [CHAR_SOUND_SNORING2] = 't_SNORING2.ogg',
    [CHAR_SOUND_SNORING3] = {'t_SNORING2.ogg', 't_SNORING1.ogg', 't_SNORING3.ogg'},
    [CHAR_SOUND_TWIRL_BOUNCE] = 't_TWIRL_BOUNCE.ogg',
    [CHAR_SOUND_UH] = 't_UH.ogg',
    [CHAR_SOUND_UH2] = 't_UH2.ogg',
    [CHAR_SOUND_UH2_2] = 't_UH2_2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 't_WAAAOOOW.ogg',
    [CHAR_SOUND_WAH2] = 't_WAH2.ogg',
    [CHAR_SOUND_WHOA] = 't_WHOA.ogg',
    [CHAR_SOUND_YAHOO] = 't_YAHOO.ogg',
    [CHAR_SOUND_YAWNING] = 't_YAWNING.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 't_YAHOO_WAHA_YIPPEE1.ogg', 't_YAHOO_WAHA_YIPPEE2.ogg', 't_YAHOO_WAHA_YIPPEE3.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = { 't_YAH_WAH_HOO1.ogg', 't_YAH_WAH_HOO2.ogg', 't_YAH_WAH_HOO3.ogg'}
    }
local VOICETABLE_MOUSER = {
    [CHAR_SOUND_ATTACKED] = 'mouser_attacked.ogg',
    [CHAR_SOUND_COUGHING1] = 'mouser_coughing.ogg',
    [CHAR_SOUND_DOH] = 'mouser_doh.ogg',
    [CHAR_SOUND_DROWNING] = 'mouser_drowning.ogg',
    [CHAR_SOUND_DYING] = 'mouser_dying.ogg',
    [CHAR_SOUND_EEUH] = 'mouser_eeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'mouser_ground_pound_wah.ogg',
    [CHAR_SOUND_HAHA] = 'mouser_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'mouser_haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'mouser_here_we_go.ogg',
    [CHAR_SOUND_HOOHOO] = 'mouser_hoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'mouser_hrmm.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'mouser_ima_tired.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'mouser_mama_mia.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'mouser_lets_a_go.ogg',
    [CHAR_SOUND_ON_FIRE] = 'mouser_on_fire.ogg',
    [CHAR_SOUND_OOOF] = 'mouser_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'mouser_ooof.ogg',
    [CHAR_SOUND_PANTING] = 'mouser_panting.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'mouser_panting2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'mouser_punch_hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'mouser_punch_wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'mouser_punch_yah.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'mouser_so_longa_bowser.ogg',
    [CHAR_SOUND_SNORING1] = 'mouser_snoring1.ogg',
    [CHAR_SOUND_SNORING2] = 'mouser_snoring2.ogg',
    [CHAR_SOUND_SNORING3] = {'mouser_snoring2.ogg', 'mouser_snoring1.ogg', 'mouser_snoring3.ogg'},
    [CHAR_SOUND_TWIRL_BOUNCE] = 'mouser_twirl_bounce.ogg',
    [CHAR_SOUND_UH] = 'mouser_uh.ogg',
    [CHAR_SOUND_UH2] = 'mouser_uh.ogg',
    [CHAR_SOUND_UH2_2] = 'mouser_uh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'mouser_waaaooow.ogg',
    [CHAR_SOUND_WAH2] = 'mouser_punch_wah.ogg',
    [CHAR_SOUND_WHOA] = 'mouser_doh.ogg',
    [CHAR_SOUND_YAHOO] = 'mouser_yahoo.ogg',
    [CHAR_SOUND_YAWNING] = 'mouser_yawning.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'mouser_yahoo.ogg', 'mouser_here_we_go.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = { 'mouser_punch_yah.ogg', 'mouser_punch_wah.ogg'}
    }

local capTRYCLYDE = {
    normal = smlua_model_util_get_id("tryclydes_cap_geo"),
    wing = smlua_model_util_get_id("tryclydes_wing_cap_geo"),
    metal = smlua_model_util_get_id("tryclydes_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("tryclydes_metal_wing_cap_geo")
}
local capMOUSER = {
    normal = smlua_model_util_get_id("mousers_cap_geo"),
    wing = smlua_model_util_get_id("mousers_wing_cap_geo"),
    metal = smlua_model_util_get_id("mousers_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("mousers_metal_wing_cap_geo")
}

local PALETTE_TRYCLYDE = {
    [SHIRT] = "DB343F",
    [SHOES] = "ffffff",
    [HAIR] = "ffffff",
    [CAP] = "F8F800",
    [PANTS] = "2391E6",
    [GLOVES] = "ffffff",
    [SKIN] = "FFFD9E",
    [EMBLEM] = "ffffff",
}
local PALETTE_MOUSER = {
    [SHIRT] = "ff51a4",
    [SHOES] = "CD422B",
    [HAIR] = "ffffff",
    [CAP] = "ffffff",
    [PANTS] = "da4ce0",
    [GLOVES] = "ffffff",
    [SKIN] = "ffffff",
    [EMBLEM] = "ffffff",
}

local PM_TRYCLYDE= {
    label = {
        left = get_texture_info("tryclyde_pm1"),
        right = get_texture_info("tryclyde_pm2"),
    },
    pie = { 
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),
        
    }
}
local PM_MOUSER= {
    label = {
        left = get_texture_info("mouser_pm1"),
        right = get_texture_info("mouser_pm2"),
    },
    pie = { 
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),
        
    }
}

local tryclydeplayerAnims = {
    [CHAR_ANIM_RUNNING] = 'tryclyde_running',
    [CHAR_ANIM_WALKING] = 'tryclyde_walking',
    [CHAR_ANIM_TIPTOE] = 'tryclyde_tiptoe',
}

if _G.charSelectExists then
    CT_TRYCLYDE = _G.charSelect.character_add("Tryclyde", "Three Heads are better than one! get ready to get toasted! Voice by TriplSpace", "Melzinoff", {r = 255, g = 200, b = 200}, E_MODEL_TRYCLYDE, CT_MARIO, TEX_TRYCLYDE)
    CT_MOUSER = _G.charSelect.character_add("Mouser", "It's the bugger himself, from Mario 2! He be the sherff of this town. Voice by MuzzLeFlash", "wibblus", {r = 200, g = 200, b = 200}, E_MODEL_MOUSER, CT_WARIO, TEX_MOUSER_ICON)


    _G.charSelect.character_add_caps(E_MODEL_TRYCLYDE, capTRYCLYDE)
    _G.charSelect.character_add_caps(E_MODEL_MOUSER, capMOUSER)

    _G.charSelect.character_add_palette_preset(E_MODEL_TRYCLYDE, PALETTE_TRYCLYDE)
    _G.charSelect.character_add_palette_preset(E_MODEL_MOUSER, PALETTE_MOUSER)

    _G.charSelect.character_add_health_meter(CT_TRYCLYDE, PM_TRYCLYDE)
    _G.charSelect.character_add_health_meter(CT_MOUSER, PM_MOUSER)

    -- the following must be hooked for each character added
    _G.charSelect.character_add_voice(E_MODEL_TRYCLYDE, VOICETABLE_TRYCLYDE)
    _G.charSelect.character_add_voice(E_MODEL_MOUSER, VOICETABLE_MOUSER)

    _G.charSelect.character_add_animations(E_MODEL_TRYCLYDE, tryclydeplayerAnims)


    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_TRYCLYDE then return _G.charSelect.voice.sound(m, sound) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_MOUSER then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_TRYCLYDE then return _G.charSelect.voice.snore(m) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_MOUSER then return _G.charSelect.voice.snore(m) end

    end)

end
